#> end_cit_leg:buildings/pregen_building
#
# Uses the data from the selected structure to run the chances for placement 
# fail or placement size decay to smaller buildings
#
# Sets up parameters for the macro placement function, particularly rotation

execute store result score $generated end_cit_leg.data run scoreboard players set $chance end_cit_leg.data 0
scoreboard players set $rotation end_cit_leg.data -1

# Fail chance
execute store result score $random end_cit_leg.data run random value 1..100
execute store result score $chance end_cit_leg.data run data get storage end_cit_leg:structure structure.failChance
execute if score $random end_cit_leg.data <= $chance end_cit_leg.data run return 0

# Decay chance
execute store result score $random end_cit_leg.data run random value 1..100
execute store result score $chance end_cit_leg.data run data get storage end_cit_leg:structure structure.decayChance
execute if score $random end_cit_leg.data <= $chance end_cit_leg.data run return -2

execute store result score $x_size end_cit_leg.data run data get storage end_cit_leg:structure structure.x_size
execute store result score $x_offset end_cit_leg.data run data get storage end_cit_leg:structure structure.x_offset
execute store result storage end_cit_leg:structure structure.x_check_1 int 1 run scoreboard players operation $x_size end_cit_leg.data -= $x_offset end_cit_leg.data
execute store result storage end_cit_leg:structure structure.x_check_2 int 1 run scoreboard players add $x_offset end_cit_leg.data 1

execute store result score $z_size end_cit_leg.data run data get storage end_cit_leg:structure structure.z_size
execute store result score $z_offset end_cit_leg.data run data get storage end_cit_leg:structure structure.z_offset
execute store result storage end_cit_leg:structure structure.z_check_1 int 1 run scoreboard players operation $z_size end_cit_leg.data -= $z_offset end_cit_leg.data
execute store result storage end_cit_leg:structure structure.z_check_2 int 1 run scoreboard players add $z_offset end_cit_leg.data 1

# Place the structure
execute if data storage end_cit_leg:structure {structure:{randomRotation:true}} store result score $rotation end_cit_leg.data run random value 0..3
execute if score $rotation end_cit_leg.data matches -1 run function end_cit_leg:buildings/technical/process_entity_rotation
scoreboard players operation $rotation end_cit_leg.data *= #90 end_cit_leg.data

execute store result storage end_cit_leg:structure structure.Angle int 1 run scoreboard players get $rotation end_cit_leg.data
function end_cit_leg:buildings/technical/process_rotation with storage end_cit_leg:structure structure

data merge storage end_cit_leg:macro {random_x:0, random_z:0}
execute if data storage end_cit_leg:structure structure{randomPosition:true} run function end_cit_leg:buildings/technical/get_random_offset with storage end_cit_leg:structure structure
return run function end_cit_leg:buildings/technical/random_offset with storage end_cit_leg:macro