#> end_cit_leg:buildings/select
#
# Root building placement function
#
# Reads from the entity tags of the executing entity to determine building type
# and store that in `$size`, to handle building size decay
#
# Reads the `$override_size` scoreboard flag in `end_cit_leg.data` to allow size 
# override for decaying structure levels
#
# Returns: 1 if building placed, 0 if not

execute unless block ~ ~ ~ minecraft:air run return run kill @s[type=minecraft:marker]
execute unless block ~ ~-1 ~ #end_cit_leg:terrain_blocks unless entity @s[tag=arch_generator] run return run kill @s[type=minecraft:marker]
execute if entity @s[tag=arch_generator] unless block ~ ~-1 ~ #end_cit_leg:road_blocks run return run kill @s[type=minecraft:marker]

execute unless score $override_size end_cit_leg.data matches 1 run scoreboard players set $size end_cit_leg.data 0
scoreboard players set $override_size end_cit_leg.data 0
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=small_building_generator] run scoreboard players set $size end_cit_leg.data 1
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=medium_building_generator] run scoreboard players set $size end_cit_leg.data 2
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=large_building_generator] run scoreboard players set $size end_cit_leg.data 3
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=long_building_generator] run scoreboard players set $size end_cit_leg.data 4
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=decor_generator] run scoreboard players set $size end_cit_leg.data 5
execute if score $size end_cit_leg.data matches 0 if entity @s[tag=arch_generator] run scoreboard players set $size end_cit_leg.data 6

execute if score $size end_cit_leg.data matches 0 run return run kill @s

# Randomly select the structure to be placed
execute if score $size end_cit_leg.data matches 1 run data modify storage end_cit_leg:macro root set value "Small"
execute if score $size end_cit_leg.data matches 1 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures Small.Structures

execute if score $size end_cit_leg.data matches 2 run data modify storage end_cit_leg:macro root set value "Medium"
execute if score $size end_cit_leg.data matches 2 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures Medium.Structures

execute if score $size end_cit_leg.data matches 3 run data modify storage end_cit_leg:macro root set value "Large"
execute if score $size end_cit_leg.data matches 3 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures Large.Structures

execute if score $size end_cit_leg.data matches 4 run data modify storage end_cit_leg:macro root set value "Long"
execute if score $size end_cit_leg.data matches 4 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures Long.Structures

execute if score $size end_cit_leg.data matches 5 run data modify storage end_cit_leg:macro root set value "SideDecor"
execute if score $size end_cit_leg.data matches 5 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures SideDecor.Structures

execute if score $size end_cit_leg.data matches 6 run data modify storage end_cit_leg:macro root set value "ArchDecor"
execute if score $size end_cit_leg.data matches 6 store result score $n end_cit_leg.data run data get storage end_cit_leg:structures ArchDecor.Structures

data remove storage end_cit_leg:structure structure
execute unless score $n end_cit_leg.data matches 1.. run return 0
scoreboard players remove $n end_cit_leg.data 1
execute store result storage end_cit_leg:macro n int 1 run scoreboard players get $n end_cit_leg.data
function end_cit_leg:random/select.root.n with storage end_cit_leg:macro

scoreboard players set $n end_cit_leg.data 0
data remove storage end_cit_leg:macro root
data remove storage end_cit_leg:macro n

execute store result score $result end_cit_leg.data run function end_cit_leg:buildings/pregen_building

# Clear storage
data remove storage end_cit_leg:structure structure

# Failed due to ground area check (tile generation)
execute if score $result end_cit_leg.data matches -1 run return 0

# Generated, or failed to generate due to macro error with structure name
kill @s[type=minecraft:marker]
execute if score $result end_cit_leg.data matches 1 run return 1
execute if score $result end_cit_leg.data matches 0 run return 0

#Decay handling (returned -2)
execute if data storage end_cit_leg:structure {structure:{decayChance:0}} run return 0
scoreboard players remove $size end_cit_leg.data 1
scoreboard players set $override_size end_cit_leg.data 1
execute if score $size end_cit_leg.data matches 0 run return -1
return run function end_cit_leg:buildings/select