#> end_cit_leg:load
# Load function - refreshes key randomisation data allowing updating and 
# reloading of the pack

schedule clear #end_cit_leg:ticking

# Setup scoreboards
scoreboard objectives add end_cit_leg.data dummy
scoreboard players set #90 end_cit_leg.data 90
scoreboard players set #2 end_cit_leg.data 2
scoreboard players set #4 end_cit_leg.data 4

scoreboard players set #north end_cit_leg.data 1
scoreboard players set #east end_cit_leg.data 2
scoreboard players set #south end_cit_leg.data 4
scoreboard players set #west end_cit_leg.data 8

# Define storages (DHP)
#define storage end_cit_leg:structures Structure lists
#define storage end_cit_leg:structure Selected structure (for macros)
#define storage end_cit_leg:data Data storage for operations

#define storage end_cit_leg:macro Data storage for macros

# Initialise standard data
data merge storage end_cit_leg:data {Rotations:{0:"clockwise_90", 90:"180", 180:"counterclockwise_90", 270:"none"}}
# data merge storage end_cit_leg:data {Tile:{Tiles:["Tiles.Empty","Tiles.DeadEnd","Tiles.DeadEnd","Tiles.Corner","Tiles.DeadEnd","Tiles.Straight","Tiles.Corner","Tiles.TJunction","Tiles.DeadEnd","Tiles.Corner","Tiles.Straight","Tiles.TJunction","Tiles.Corner","Tiles.TJunction","Tiles.TJunction","Tiles.Cross"]}}
# data merge storage end_cit_leg:data {Tile:{Angles:[180,180,270,180,0,180,270,180,90,90,270,90,0,0,270,180]}}
# data merge storage end_cit_leg:data {Tile:{Rotations:["none","none","clockwise_90","none","180","none","clockwise_90","none",counterclockwise_90,"counterclockwise_90","clockwise_90","counterclockwise_90","180","180","clockwise_90","none"]}}
data merge storage end_cit_leg:data {Tile:{Rotations:["none", "clockwise_90", "180", "counterclockwise_90"]}}
data merge storage end_cit_leg:data {Tile:{Angles:["180", "270", "0", "90"]}}

execute unless score $setup end_cit_leg.data matches 1 run scoreboard players set $reload_structures end_cit_leg.data 1
# execute if score $reload_structures end_cit_leg.data matches 0 run return 0
# Reset structure lists
data modify storage end_cit_leg:structures Small.Structures set value []
data modify storage end_cit_leg:structures Medium.Structures set value []
data modify storage end_cit_leg:structures Long.Structures set value []
data modify storage end_cit_leg:structures Large.Structures set value []
data modify storage end_cit_leg:structures SideDecor.Structures set value []
data modify storage end_cit_leg:structures ArchDecor.Structures set value []

data merge storage end_cit_leg:data {Tile:{Size:33}}
data modify storage end_cit_leg:structures Tiles.Structures set value []

# Add the structures
function #end_cit_leg:structure_config
# If no structures are present, add default structures
function end_cit_leg:default_structure_config

function end_cit_leg:init/init_randomisation


# -------------------- Structure configuration --------------------
#
# - Only the fields which should be user-edited are shown - nothing else should be added, 
#   though temp data can be created for using duplicate data, and then destroyed again.
#
# - User-defined structures must be added to their correct storages via a function run 
#   from the `#end_cit_leg:structure_config` tag (user defined functions can be freely added 
#   to this, beyond the built-in optional module functions) to ensure they are loaded at 
#   the correct stage in pre-generation. Do not modify the storages from other load 
#   functions et cetera as this can and will cause issues.

# ---------- Road tiles ----------
#
# Storage `end_cit_leg:data`
# {
#   Tiles: 
#   {
#     Size <int>  
#       # Side length of the tile structures
#       # This is set in the "end_cit_leg:load" function, on line 41
#   }
# }
#
# Storage `end_cit_leg:structures`
# {
#   Tiles: {
#     <str: Empty|DeadEnd|Straight|Corner|TJunction|Cross>: 
#     {
#       Structures: 
#       [
#         <entry>
#       ]
#     }
#   }
# }
#
# Entry format:
# {
#   Name <str>  
#     # Namespaced id for structure (.nbt) file
#   weight <int>  
#     # Randomisation weight for this tile to generate from the list of tiles in this size
# }

# ---------- City structures ----------
#
# ### Storage `end_cit_leg:structures`
# {
#   <str: Small|Medium|Long|Large|SideDecor|ArchDecor>: 
#   {
#     Structures: 
#     [
#       <compound - entry>
#     ]
#   }
# }
#
# Entry format:
# {
#   Name <str>  # Namespaced id for structure (.nbt) file
#
#   # Offset from centre (where the marker entity which spawns the structure is placed) and the bottom north-west corner
#   x_offset <int>
#   y_offset <int>
#   z_offset <int>
#
#   # Structure file dimensions (as shown in structure block)
#   x_size <int> 
#   y_size <int>
#   z_size <int>
#
#   failChance <int> 
#     # The chance (out of 100) for the structure to not place
#   decayChance <int> 
#     # The chance (out of 100) for the structure to decay down to the next size level
#
#   randomRotation <bool>
#     # Whether or not the structure should rotate randomly (about the marker entity) or inherit its rotation from the marker entity
#   randomPosition <bool>
#     # Whether the structure should randomly offset by up to 2 blocks in the x/y directions
#
#   weight <int>
#     # Randomisation weight for this tile to generate from the list of tiles in this size
#
#   # Stacked building configuration (multiple randomised layers)
#   Stack <compound> (optional):
#   {
#     Limit <str>
#       # namespaced id for the predicate which limits the structure height
#     Offset <int>
#       # the vertical offset to place each subsequent layer
#     failChance <int>
#       # the chance for each layer to be the final layer (i.e. the stack terminates)
#     minStackCount <int>
#       # the minimum number of layers to place
#
#     # List of namespaced ids for structure (.nbt) files
#     Structures: 
#     [
#       <str - structure file id>
#     ]
#   }
#
#   PostProcessors <list compound> (optional):
#   [
#     <compound - Post processor>
#   ]
# }
#
# Post processor format:
# {
#   type <enum replace_random|replace_random_rotated>
#     # The processor type
#
#   # Relative position of the block to be replaced, from the bottom north-west corner of the structure 
#   x <int>
#   y <int>
#   z <int>
#
#   require_air <bool> (optional)
#     # Whether or not the block replacement requires the block being replaced to be air (defaults to false)
#
#   # List of namespaced block ids to select from to replace the given block with
#   blocks: 
#   [
#     <str - block id>
#   ]
#
#   # IF (type: replace_random_rotated)
#   # List of block-data entries - 4 entries, corresponding to the different 
#   #   e.g. ["[rotation=0]","[rotation=4]","[rotation=8]","[rotation=12]"]
#   data: 
#   [
#     <str>
#   ]
# }